-- Load our configs
local function init()	
	-- Load our banned users
	if file.Exists( "../cfg/banned_user.cfg" ) then
		ULib.execFile( "../cfg/banned_user.cfg" )
	end
	
	for category, data in pairs( ulx.help ) do
		table.sort( data, function (a,b) -- Sort our help
			return (a.cmd < b.cmd)
		end )
	end
	
	for category, data in pairs( ulx.convarhelp ) do
		table.sort( data, function (a,b) -- Sort our help
			return (a.cmd < b.cmd)
		end )
	end
end
hook.Add( "Initialize", "ULXInitialize", init )

-- We're setting up our own mini-timer here to run the configs because ded server timers don't start until a player joins.
local starttime = RealTime()
local function doCfg()
	if RealTime() - starttime < 5 then return end -- Not enough time yet.
	
	if not file.Exists( "../cfg/server.ini" ) then
		Msg( "[ULX] ERROR: The server.ini file is missing!\n" )
	else
		ULib.execFile( "../cfg/server.ini" )
	end
	
	-- Per gamemode config
	if file.Exists( "../cfg/gamemodes/" .. GAMEMODE.Name:lower() .. ".ini" ) then
		ULib.execFile( "../cfg/gamemodes/" .. GAMEMODE.Name:lower() .. ".ini" )
	end
	
	-- Per map config
	if file.Exists( "../cfg/maps/" .. game.GetMap() .. ".ini" ) then
		ULib.execFile( "../cfg/maps/" .. game.GetMap() .. ".ini" )
	end	
	
	timer.Simple( FrameTime() / 2 , ulx.DoDoneCallbacks ) -- We're done loading! Wait a tick so the configs load.
	
	hook.Remove( "Think", "ULXDoCfg" )
end
hook.Add( "Think", "ULXDoCfg", doCfg )