local controls
local lastvalues = {}

local function rcvValues( um )
	local cvar = um:ReadString()
	local value = um:ReadShort()
	
	for _, control in ipairs( controls ) do
		if control.data.cvar == cvar then
			if not control.data.button then
				control:PostMessage( "SetValue", "f", value )
				lastvalues[ cvar ] = value
			else
				if value == 1 then
					control:SetText( control.data.on )
				else
					control:SetText( control.data.off )
				end				
			end
		end
	end
end
usermessage.Hook( "ulx_menuvalues", rcvValues )

local function doApply()
	for _, control in ipairs( controls ) do
		if not control.data.button then
			local data = ulx.adminMenuContents[ control.label:GetValue() ]
			
			if not data.denyOverflow then
				control:PostMessage( "SetHigher", "f", math.max( ( 2 * control.value ), data.max ) )
			end
			
			if control.value ~= lastvalues[ control.data.cvar ] then
				lastvalues[ control.data.cvar ] = control.value
				LocalPlayer():ConCommand( "ulx_cvar " ..  control.data.cvar .. " " .. control.value )
			end
		end
	end
end

local function btnPress( control )
	local command = "ulx_cvar " .. control.data.cvar
	if control:GetValue() == control.data.off then
		command = command .. " 1\n"
		control:SetText( control.data.on )
	else
		command = command .. " 0\n"
		control:SetText( control.data.off )
	end
	
	LocalPlayer():ConCommand( command )
end

function ulx.showAdminMenu()
	if not ULib.isSandbox() then
		ULib.csay( LocalPlayer(), "Sorry, this menu is only available in a sandbox gamemode." )
		return
	end

	LocalPlayer():ConCommand( "ulx_valueupdate\n" )
	controls = {}
	
	local window = vgui.Create( "DFrame" )
	window:SetSize( 640, 480 )
	window:Center()
	window:SetTitle( "ULX Admin Menu" )
	window:SetVisible( true )
	window:MakePopup()

	local t = {}
	for _, data in pairs( ulx.adminMenuContents ) do
		if data.button then
			t[ data.off ] = data
		end
	end
	local newcontrols	
	local options = {}
	options.columns = 1
	options.wide = 150
	options.visibleRows = 15
	options.buttonWide = 140
	options.buttonTall = 24
	options.vspacing = 5
	options.callback = btnPress
	local panel1, newcontrols = ulx.controlListMaker( window, t, options )
	panel1:SetPos( 10, 30 )
	table.Add( controls, newcontrols )
	
	t = {}
	for lbl, data in pairs( ulx.adminMenuContents ) do
		if not data.button then
			t[ lbl ] = data
		end
	end	
	newcontrols = nil
	options = {}
	options.columns = 2
	options.wide = 460
	options.visibleRows = 9
	options.buttonWide = 200
	options.buttonTall = 20
	options.vspacing = 2
	options.controlName = "Slider"	
	local panel2, newcontrols = ulx.sliderListMaker( window, t, options )
	panel2:SetPos( panel1.X + panel1:GetWide() + 10, 30 )		
	table.Add( controls, newcontrols )
	
	local apply = vgui.Create( "DButton", window )
	apply:SetSize( 100, 40 )
	apply:SetPos( panel2.X + (panel2:GetWide() - apply:GetWide())/2, panel2.Y + panel2:GetTall() + 15 )
	apply:SetText( "Apply" )
	apply.DoClick = doApply
end
