local selectedply

local function radioPress( btn )
	selectedply = btn.data
end

local function btnPress( btn )
	if not selectedply or not selectedply:IsValid() then return end -- No one has been selected.
	
	local dummy, dummy, command, args = string.find( btn.data, "(%a+)%s*(.*)" )
	if not args:find( "#T" ) then args = args .. " #T" end -- If they didn't specify where to stick the player, add it to end.
	args = args:gsub( "#T", "\"" .. selectedply:Nick() .. "\"", 1 )
	ULib.redirect( LocalPlayer(), command, _,  args ) -- So we don't have to use ConCommand() and risk it being blocked.
end

function ulx.showClientMenu()
	selectedply = nil
	
	local window = vgui.Create( "DFrame" )
	window:SetSize( 640, 480 )
	window:Center()
	window:SetTitle( "ULX Client Menu" )
	window:SetVisible( true )
	window:MakePopup()

	local players = player.GetAll()
	local t = {}
	for _, ply in ipairs( players ) do
		t[ ply:Nick() ] = ply
	end
	local options = {}
	options.columns = 1
	options.wide = 210
	options.visibleRows = 22
	options.buttonWide = 205
	options.buttonTall = 15
	options.vspacing = 5
	options.callback = radioPress
	options.controlName = "RadioButton"
	local panel1 = ulx.controlListMaker( window, t, options )
	panel1:SetPos( 10, 30 )
	
	t = {}
	for k, v in pairs( ulx.clientMenuContents ) do
		local dummy, dummy, command, args = string.find( v, "(%a+)%s*(.*)" )
		if command == "ulx" then
			dummy, dummy, command2, args = string.find( args, "(%a+)%s*(.*)" )
			command = command .. " " .. command2
		end
		if ULib.ucl.query( LocalPlayer(), command ) then
			t[ k ] = v
		end
	end	
	options = {}
	options.columns = 4
	options.wide = 400
	options.visibleRows = 11
	options.buttonWide = 80
	options.buttonTall = 30
	options.vspacing = 10
	options.callback = btnPress
	local panel2 = ulx.controlListMaker( window, t, options )
	panel2:SetPos( panel1.X + panel1:GetWide() + 10, 30 )	
end
usermessage.Hook( "SendClientMenu", ulx.showClientMenu )